/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ls_lst.c                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: vibucho <marvin@42.fr>                     +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/11/25 23:36:44 by vibucho           #+#    #+#             */
/*   Updated: 2014/12/01 13:48:20 by vibucho          ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */
#include "ft_ls.h"

void ft_lstadd(t_list **alst, t_list *new)
{
	if(new)
	{
		new->next = *alst;
		*alst = new;
	}
}

void ft_lstendadd(t_list **alst, t_list *new)
{
	t_list *tmp;

	if(*alst)
	{
		tmp = *alst;
		while((tmp->next) != NULL)
		{
			tmp = tmp->next;
		}
		tmp->next = new;
		return ;
	}
	*alst = new;
}

t_list 	*ft_lstnew(void const *content)
{
	t_list *new_list;

	new_list = (t_list *)malloc(sizeof(t_list));
	if(new_list == NULL)
		return (NULL);
	else
	{
		new_list->str = (char*)content;
		new_list->next = NULL;
	}
	return(new_list);
}

void    ft_inlst(t_list **alst, t_list *new)
{
    t_list *list = *alst;
     if(list == NULL)
     {
         *alst = new;
         return ;
     }
     if (ft_strcmp(new->str, list->str) < 0)
     {
        new->next = list;
        *alst = new;
         return ;
     }
    while ((list->next) != NULL)
    {
        if(ft_strcmp(new->str,list->next->str) < 0)
        {
            new->next = list->next;
            list->next = new;
            return ;
        }
        list = list->next;
    }
    list->next = new;
}

void	ft_rinlst(t_list **alst, t_list *new)
{
    t_list *list = *alst;
     if(list == NULL)
     {
         *alst = new;
         return ;
     }
     if (ft_strcmp(list->str, new->str) < 0)
     {
        new->next = list;
        *alst = new;
         return ;
     }
    while ((list->next) != NULL)
    {
        if(ft_strcmp(list->next->str,new->str) < 0)
        {
            new->next = list->next;
            list->next = new;
            return ;
        }
        list = list->next;
    }
    list->next = new;
}